<template>
    <div class="">
        <div class="row">
            <div class="login__form  col-6 offset-3">
                <form class="bg-white border rounded p-4">
                    <div class="form-group">
                        <label for="email">Email address <span class="text-danger">*</span></label>
                        <input type="email" class="form-control" id="email" v-model="form.email"
                               :class="{'is-invalid' : $v.form.email.$error }"
                               @input="$v.form.email.$touch"
                               aria-describedby="emailHelp" placeholder="Enter email address">
                        <div v-if="$v.form.email.$error" class="invalid-feedback">
                            Valid email is required.
                        </div>
                        <small id="emailHelp" class="form-text text-muted">We'll never share your email with anyone
                            else.</small>
                    </div>
                    <div class="form-group">
                        <label for="password">Password</label>
                        <input type="password" class="form-control" id="password" placeholder="Password"
                               :class="{'is-invalid' : $v.form.password.$error }"
                               @input="$v.form.password.$touch"
                               v-model="form.password">
                        <div v-if="$v.form.password.$error" class="invalid-feedback">
                            Valid password with minimum 6 character is required.
                        </div>
                    </div>
                    <button type="submit" class="btn btn-block btn-info" @click.prevent="login()"
                            :disabled="$v.form.$invalid"
                            :class="{ disabled : $v.form.$invalid}">Login
                    </button>
                    <div>
                        <small v-if="$v.form.$error" class="text-danger">
                            Please check the form again.
                        </small>
                        <small v-if="status==='ERROR'" class="text-danger">
                            Something went wrong. Please try again
                        </small>
                    </div>
                    <div class="text-center mt-1">
                        <router-link to="/register">Sign up</router-link>
                    </div>
                </form>
            </div>
        </div>

    </div>
</template>

<script>
    import {required, email, minLength} from 'vuelidate/lib/validators'

    export default {
        name: "Login",
        data() {
            return {
                form: {},
                status: 'SAVED'
            }
        },
        props: {
            nextUrl: {type: String, default: "/"}
        },
        validations: {
            form: {
                email: {
                    required,
                    email
                },
                password: {
                    required,
                    minLength: minLength(6)
                }
            }

        },
        methods: {
            login() {
                let data = this.form;
                this.$http.post('login', data)
                    .then((response) => {
                        let token = response.data.data.access_token;
                        localStorage.setItem('token', token);
                        this.$router.push(this.nextUrl)
                    }).catch((e) => {
                    this.status = 'ERROR'
                });

            }
        }
    }
</script>

<style scoped>

</style>
